#include <assert.h>
#include <stdio.h>
const MaxBufLen = 100, MaxLine = 1600, MaxDir = 6;
char huge s[MaxLine][MaxBufLen];

const MaxFN = 4;
char fn[MaxFN][90] = {"a2.prg", "a2m.prg", "a2begin.prg", "a2end.prg"};

int readstr (FILE * f1, char * str)
{
 int c, n = 0;
 while (((c = getc (f1)) != 0x0A) && (c != 0x0D) && (c != EOF))
 {
  str[n++] = c;
  assert (n < MaxBufLen);
 }
 str[n] = 0;
 if (c == 0x0D) c = getc (f1); // to read 0x0A
 return (c);
}

int readblank (int pos, char * str)
{
 for (; (str[pos] > 0) && (str[pos] <= 0x20); pos++) {}
 return (pos);
}

int readterm (int pos, char * str)
{
 for (; str[pos] > 0x20; pos++) {}
 return (pos);
}

int readfirstnum (int pos1, int pos2, char * str)
{
 for (; (pos1 < pos2) && ((str[pos1] < '0') || (str[pos1] > '5')); pos1++) {}
 return (pos1);
}

void main (int argc, char * argv [])
{
 int i, j, k, l, m, n;
 FILE * f1, * f2;
 for (i = 1; (i < argc) && (i <= MaxFN); i++)
  for (j = 0; (fn[i - 1][j] = argv[i][j]) != 0; j++) {}
 f2 = fopen (fn[1], "wb");
 f1 = fopen (fn[2], "rb");
 for (; readstr (f1, (char *) s[0]) != EOF; )
  fprintf (f2, "%s\n", s[0]);
 fclose (f1);
 f1 = fopen (fn[0], "rb");
 for (n = 0; readstr (f1, (char *) s[n]) != EOF; n++) {}
 for (i = 0; i < MaxDir; i++)
  for (k = 0; k < n; k++)
  {
   fprintf (f2, "%s\n", s[k]);
   m = 0;
   while (s[k][m] > 0)
   {
    j = readblank (m, (char *) s[k]);
    if (s[k][m] == 0) break;
    m = readterm (j, (char *) s[k]);
    l = readfirstnum (j, m, (char *) s[k]);
    if ((l > j + 1) && (l < m))
    {s[k][l]++; if (s[k][l] > '5') s[k][l] = '0';}
   }
  }
 fclose (f1);
 f1 = fopen (fn[3], "rb");
 for (; readstr (f1, (char *) s[0]) != EOF; )
  fprintf (f2, "%s\n", s[0]);
 fclose (f1);
}
